#declare Old_brass = texture {
	pigment { color rgb <0.7, 0.35, 0.1> }
	finish {
		metallic
		ambient 0.2
		phong 1
		reflection 0.35
   }
}

#declare C_pad = union {
	difference {
		sphere {<0, 0, 0>, 0.5}
		sphere {<0, 0, 0>, 0.48}
		plane {-y, 0.25}
		translate y*0.65
	}
	sphere {<0, 0, 0>, 0.152}
}

#declare Shaft = union {
	torus {0.22, 0.08 rotate x*90}
	cylinder {<-1, 0, 0>, <1, 0, 0>, 0.06}
	cylinder {<0, 1, 0>, <0, -3, 0>, 0.06}
}

#declare Base = union {
	sphere {<0, 0, 0>, 0.16 translate -y*3}
	difference {
		sphere {<0, 0, 0>, 0.9 translate -y*3.9}
		plane {y, -3.2}
		scale <1.5, 1, 1.5>
	}
}

#declare Web = object {
	union {
		smooth_triangle {
		<0, 0, 0>, <0, 0, -1>,
		<0, 1, 0>, <0, 0, -1>,
		<1, 0, 0>, <0, 0, -1>
		}
		smooth_triangle {
		<0, 1, 0>, <0, 0, -1>,
		<1, 1, 0>, <0, 0, -1>,
		<1, 0, 0>, <0, 0, -1>
		}
	}
	texture {
		pigment {
			image_map {
				gif "web.gif"
				once
				map_type 0
				filter 255, 1
				interpolate 2
			}
		}
		finish { ambient 1 phong 0 }
	}
}

#declare Wax = object {
	blob {
		threshold 0.6
		component 1, 0.110367, <0, 0.900380, 0>
		component 1, 0.122961, <0, 0.783574, 0>
		component 1, 0.143454, <0, 0.657034, 0>
		component 1, 0.163948, <0, 0.509506, 0>
		component 1, 0.194859, <0, 0.326996, 0>
		component 1, 0.194859, <0, 0.144487, 0>
		component 1, 0.194859, <0, -0.053232, 0>
		component 1, 0.194859, <0, -0.235741, 0>
		component 1, 0.194859, <0, -0.433460, 0>
		component 1, 0.194859, <0, -0.615970, 0>
		component 1, 0.275496, <0, -0.798479, 0>
		component 1, 0.315485, <0, -0.996198, 0>
	}
	translate <0, -0.95, 0.05>
	scale 0.25
}

#declare Candle = merge {
	cylinder {<0, 0, 0>, <0, 1.5, 0>, 0.2 }
	object {Wax translate <0, 1.5, -0.2>}
	object {Wax scale <1, 0.5, 1> translate <0, 1.5, -0.2> rotate -y*20}
	object {Wax scale <1, 1.6, 1> translate <0, 1.5, -0.2> rotate -y*40}
	object {Wax scale <1, 0.8, 1> translate <0, 1.5, -0.2> rotate -y*60}
	object {Wax scale <1, 1.2, 1> translate <0, 1.5, -0.2> rotate -y*80}
	object {Wax scale <1, 0.6, 1> translate <0, 1.5, -0.2> rotate -y*90}
	object {Wax scale <1, 0.4, 1> translate <0, 1.5, -0.2> rotate -y*100}
	object {Wax scale <1, 1.0, 1> translate <0, 1.5, -0.2> rotate -y*125}
	object {Wax scale <1, 0.6, 1> translate <0, 1.5, -0.2> rotate -y*140}
	object {Wax scale <1, 0.4, 1> translate <0, 1.5, -0.2> rotate -y*150}
	object {Wax scale <1, 1.0, 1> translate <0, 1.5, -0.2> rotate -y*160}
	object {Wax scale <1, 0.8, 1> translate <0, 1.5, -0.2> rotate -y*170}
	object {Wax scale <1, 0.4, 1> translate <0, 1.5, -0.2> rotate -y*180}
	object {Wax scale <1, 0.6, 1> translate <0, 1.5, -0.2> rotate -y*220}
	object {Wax scale <1, 0.8, 1> translate <0, 1.5, -0.2> rotate -y*245}
	object {Wax scale <1, 0.4, 1> translate <0, 1.5, -0.2> rotate -y*260}
	object {Wax scale <1, 1.0, 1> translate <0, 1.5, -0.2> rotate -y*280}
	object {Wax scale <1, 0.3, 1> translate <0, 1.5, -0.2> rotate -y*290}
	object {Wax scale <1, 0.5, 1> translate <0, 1.5, -0.2> rotate -y*300}
	object {Wax scale <1, 0.4, 1> translate <0, 1.5, -0.2> rotate -y*320}
	object {Wax scale <1, 1.0, 1> translate <0, 1.5, -0.2> rotate -y*330}
	object {Wax scale <1, 0.6, 1> translate <0, 1.5, -0.2> rotate -y*340}
	cylinder {<0, 1.5, 0>, <0, 1.7, 0>, 0.01
		pigment {color rgb <0.1, 0.1, 0.1>}
		finish {ambient 0.2 phong 0.2}
	}
	texture {
		pigment {color rgb <1, 1, 1>}
		finish {ambient 0.3 phong 0.7}
	}
}

#declare Candles = union {
	object { Shaft }
	object { C_pad translate -x*1 }
	object { Candle scale <1, 0.6, 1> translate <-1, 0.4, 0>}
	object { C_pad translate x*1 }
	object { Candle scale <1, 0.8, 1> rotate y*45 translate <1, 0.4, 0>}
	object { C_pad translate y*1 }
	object { Candle rotate y*90 translate <0, 1.4, 0>}
	object { Base }
	object { Web scale <1, 3, 1> translate -y*3}
	object { Web scale <0.6, 2, 1> rotate y*180 translate -y*2}
	object { Web rotate x*180 translate y*1 rotate y*180}
	texture {Old_brass}
	translate y*3.2
}
